Index: issm/branches/trunk-jpl-damage/src/c/include/types.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/include/types.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/include/types.h	(revision 12878)
@@ -27,7 +27,18 @@
 #endif  
 
-typedef double IssmDouble;
+#ifdef _HAVE_ADOLC_
+#include "adolc/adolc.h"
+// for active variables
+typedef adouble IssmDouble;
+// for passive variables
+typedef double IssmPDouble;
+#else 
+// see above
+typedef double IssmDouble; 
+// see above
+typedef IssmDouble IssmPDouble;
+#endif
+
 typedef bool IssmBool;
 
-
 #endif //ifndef _TYPES_H_
Index: issm/branches/trunk-jpl-damage/src/c/io/Disk/diskio.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/io/Disk/diskio.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/io/Disk/diskio.h	(revision 12878)
@@ -6,10 +6,7 @@
 #define _DISK_IO_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 #include "../../include/include.h"
-
-class DataSet;
-class Parameters;
 
 FILE* pfopen(char* filename,const char* format);
Index: issm/branches/trunk-jpl-damage/src/c/io/Disk/pfclose.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/io/Disk/pfclose.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/io/Disk/pfclose.cpp	(revision 12878)
@@ -18,4 +18,4 @@
 	extern int my_rank;
 	_assert_(fid);
-	if(fclose(fid)!=0)_error_("%s%s","could not close file ",filename);
+	if(fclose(fid)!=0)_error2_("could not close file " << filename);
 }
Index: issm/branches/trunk-jpl-damage/src/c/io/Disk/pfopen.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/io/Disk/pfopen.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/io/Disk/pfopen.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 	/*Open handle to data on disk: */
 	fid=fopen(filename,format);
-	if(fid==NULL) _error_("%s%s%s","could not open file ",filename," for binary reading or writing"); 
+	if(fid==NULL) _error2_("could not open file " << filename << " for binary reading or writing"); 
 
 	return fid;
Index: issm/branches/trunk-jpl-damage/src/c/io/PrintfFunction.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/io/PrintfFunction.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/io/PrintfFunction.cpp	(revision 12878)
@@ -25,13 +25,9 @@
 
 		/*allocate buffer for given string size*/
-		buffer=(char*)xmalloc(size*sizeof(char));
+		buffer=xNew<char>(size);
 
 		/* Try to print in the allocated space. */
 		va_start(args, format);
-#ifndef WIN32
 		n=vsnprintf(buffer,size,format,args);
-#else
-		n=vsnprintf(buffer,size,format,args);
-#endif
 		va_end(args);
 
@@ -45,12 +41,26 @@
 		 size*=2;  /* twice the old size */
 
-		xfree((void**)&buffer);
+		xDelete<char>(buffer);
 	}
 
 	/*Ok, if we are running in parallel, get node 0 to print*/
-	if(my_rank==0)printf(buffer);
+	if(my_rank==0)_printString_(buffer);
 
 	/*Clean up and return*/
-	xfree((void**)&buffer);
+	xDelete<char>(buffer);
 	return 1;
 }
+int PrintfFunction(const string & message){
+	extern int  my_rank;
+	if(my_rank==0){
+		printf("%s\n",message.c_str());
+	}
+	return 1;
+}
+int PrintfFunction2(const string & message){
+	extern int  my_rank;
+	if(my_rank==0){
+		printf("%s",message.c_str());
+	}
+	return 1;
+}
Index: issm/branches/trunk-jpl-damage/src/c/io/io.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/io/io.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/io/io.h	(revision 12878)
@@ -6,15 +6,15 @@
 #define _ISSM_IO_H_
 
-#ifdef HAVE_CONFIG_H //config.h {{{1
+#ifdef HAVE_CONFIG_H
 #include <config.h>
 #else
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif 
-//}}}
-
 #include "./Disk/diskio.h"
 
 /*printf: */
 int PrintfFunction(const char* format,...);
+int PrintfFunction(const string & message);
+int PrintfFunction2(const string & message);
 
 #endif	/* _IO_H_ */
Index: issm/branches/trunk-jpl-damage/src/c/issm.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/issm.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/issm.h	(revision 12878)
@@ -4,5 +4,5 @@
 
 #ifndef _ISSM_H_
-#define  _ISSM_H_
+#define _ISSM_H_
 
 #ifdef HAVE_CONFIG_H
@@ -14,5 +14,5 @@
 #include "./include/include.h"
 #include "./shared/shared.h"
-#include "./objects/objects.h"
+#include "./classes/classes.h"
 #include "./Container/Container.h"
 #include "./EnumDefinitions/EnumDefinitions.h"
@@ -22,4 +22,3 @@
 #include "./modules/modules.h"
 
-
 #endif //ifndef _ISSM_H_
Index: issm/branches/trunk-jpl-damage/src/c/matlab/include/matlab_macros.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/include/matlab_macros.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/include/matlab_macros.h	(revision 12878)
@@ -3,5 +3,5 @@
  */
 
-/*Header {{{1*/
+/*Header {{{*/
 #ifndef _MATLAB_MACROS_H_
 #define _MATLAB_MACROS_H_
@@ -15,5 +15,5 @@
 
 #ifdef _HAVE_MATLAB_
-/* MODULEBOOT/MODULEEND {{{1*/
+/* MODULEBOOT/MODULEEND {{{*/
 
 /*The following macros hide the error exception handling in a matlab module. Just put 
@@ -36,9 +36,9 @@
 	}
 //}}}
-/* WRAPPER {{{1*/
+/* WRAPPER {{{*/
 #define WRAPPER(modulename,...) void mexFunction(int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]) 
 
 /*}}}*/
-/* CHECKARGUMENTS {{{1*/
+/* CHECKARGUMENTS {{{*/
 #define CHECKARGUMENTS(NLHS,NRHS,functionpointer) CheckNumMatlabArguments(nlhs,NLHS,nrhs,NRHS,__FUNCT__,functionpointer)
 /*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/CheckNumMatlabArguments.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/CheckNumMatlabArguments.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/CheckNumMatlabArguments.cpp	(revision 12878)
@@ -22,9 +22,9 @@
 		/* special case: */
 		function();
-		_error_("usage: see above");
+		_error2_("usage: see above");
 	}
 	else if (nlhs!=NLHS || nrhs!=NRHS ) {
 		function(); 
-		_error_("usage error.");
+		_error2_("usage error.");
 	}
 	return 1;
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/FetchMatlabData.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/FetchMatlabData.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/FetchMatlabData.cpp	(revision 12878)
@@ -15,5 +15,5 @@
 
 /*Primitive data types*/
-/*FUNCTION FetchData(double** pmatrix,int* pM,int *pN,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(double** pmatrix,int* pM,int *pN,const mxArray* dataref){{{*/
 void FetchData(double** pmatrix,int* pM,int *pN,const mxArray* dataref){
 
@@ -27,5 +27,9 @@
 		outmatrix=NULL;
 	}
-	else if(mxIsClass(dataref,"double") || mxIsClass(dataref,"single")){
+	else if( mxIsClass(dataref,"double") || 
+				mxIsClass(dataref,"single") || 
+				mxIsClass(dataref,"int16") || 
+				mxIsClass(dataref,"int8") || 
+				mxIsClass(dataref,"uint8")){
 		/*Check dataref is not pointing to NaN: */
 		if ( mxIsNaN(*(mxGetPr(dataref))) && (mxGetM(dataref)==1) && (mxGetN(dataref)==1) ){
@@ -35,4 +39,7 @@
 		}
 		else{
+			if(!mxIsClass(dataref,"double") && !mxIsClass(dataref,"single")){
+				_printLine_("Warning: converting matlab data from '" << mxGetClassName(dataref) << "' to 'double'");
+			}
 			/*Convert matlab matrix to double* matrix: */
 			MatlabMatrixToDoubleMatrix(&outmatrix,&outmatrix_rows,&outmatrix_cols,dataref);
@@ -41,5 +48,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 			
@@ -51,5 +58,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(double** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(double** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{*/
 void FetchData(double** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){
 
@@ -82,5 +89,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 			
@@ -90,9 +97,9 @@
 	if (pndims)*pndims=outmatrix_ndims;
 	if (psize )*psize =outmatrix_size;
-	else xfree((void**)&outmatrix_size);
-
-}
-/*}}}*/
-/*FUNCTION FetchData(int** pmatrix,int* pM,int *pN,const mxArray* dataref){{{1*/
+	else xDelete<int>(outmatrix_size);
+
+}
+/*}}}*/
+/*FUNCTION FetchData(int** pmatrix,int* pM,int *pN,const mxArray* dataref){{{*/
 void FetchData(int** pmatrix,int* pM,int *pN,const mxArray* dataref){
 
@@ -121,5 +128,5 @@
 
 			/*Convert double matrix into integer matrix: */
-			outmatrix=(int*)xmalloc(outmatrix_rows*outmatrix_cols*sizeof(int));
+			outmatrix=xNew<int>(outmatrix_rows*outmatrix_cols);
 			for(i=0;i<outmatrix_rows*outmatrix_cols;i++)outmatrix[i]=(int)doublematrix[i];
 		}
@@ -127,5 +134,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -136,5 +143,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(bool** pmatrix,int* pM,int *pN,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(bool** pmatrix,int* pM,int *pN,const mxArray* dataref){{{*/
 void FetchData(bool** pmatrix,int* pM,int *pN,const mxArray* dataref){
 
@@ -163,5 +170,5 @@
 
 			/*Convert double matrix into integer matrix: */
-			outmatrix=(bool*)xmalloc(outmatrix_rows*outmatrix_cols*sizeof(bool));
+			outmatrix=xNew<bool>(outmatrix_rows*outmatrix_cols);
 			for(i=0;i<outmatrix_rows;i++)outmatrix[i]=(bool)doublematrix[i];
 		}
@@ -169,5 +176,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -178,5 +185,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(bool** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(bool** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{*/
 void FetchData(bool** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){
 
@@ -224,12 +231,12 @@
 
 			/*Convert double matrix into bool matrix: */
-			outmatrix=(bool*)xmalloc(outmatrix_numel*sizeof(bool));
+			outmatrix=xNew<bool>(outmatrix_numel);
 			for(i=0;i<outmatrix_numel;i++)outmatrix[i]=(bool)doublematrix[i];
-			xfree((void**)&doublematrix);
-		}
-	}
-	else{
-		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+			xDelete<double>(doublematrix);
+		}
+	}
+	else{
+		/*This is an error: we don't have the correct input!: */
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 			
@@ -239,9 +246,9 @@
 	if (pndims)*pndims=outmatrix_ndims;
 	if (psize )*psize =outmatrix_size;
-	else xfree((void**)&outmatrix_size);
-
-}
-/*}}}*/
-/*FUNCTION FetchData(double** pvector,int* pM,const mxArray* dataref){{{1*/
+	else xDelete<int>(outmatrix_size);
+
+}
+/*}}}*/
+/*FUNCTION FetchData(double** pvector,int* pM,const mxArray* dataref){{{*/
 void FetchData(double** pvector,int* pM,const mxArray* dataref){
 
@@ -262,5 +269,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -270,5 +277,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(int** pvector,int* pM,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(int** pvector,int* pM,const mxArray* dataref){{{*/
 void FetchData(int** pvector,int* pM,const mxArray* dataref){
 
@@ -289,10 +296,10 @@
 
 		/*Convert double vector into integer vector: */
-		outvector=(int*)xmalloc(outvector_rows*sizeof(int));
+		outvector=xNew<int>(outvector_rows);
 		for(i=0;i<outvector_rows;i++)outvector[i]=(int)doublevector[i];
 	}
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -302,5 +309,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(bool** pvector,int* pM,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(bool** pvector,int* pM,const mxArray* dataref){{{*/
 void FetchData(bool** pvector,int* pM,const mxArray* dataref){
 
@@ -321,10 +328,10 @@
 
 		/*Convert double vector into integer vector: */
-		outvector=(bool*)xmalloc(outvector_rows*sizeof(bool));
+		outvector=xNew<bool>(outvector_rows);
 		for(i=0;i<outvector_rows;i++)outvector[i]=(bool)doublevector[i];
 	}
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -334,5 +341,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(float** pvector,int* pM,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(float** pvector,int* pM,const mxArray* dataref){{{*/
 void FetchData(float** pvector,int* pM,const mxArray* dataref){
 
@@ -353,10 +360,10 @@
 
 		/*Convert double vector into float vector: */
-		outvector=(float*)xmalloc(outvector_rows*sizeof(float));
+		outvector=xNew<float>(outvector_rows);
 		for(i=0;i<outvector_rows;i++)outvector[i]=(float)doublevector[i];
 	}
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -366,5 +373,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(char** pstring,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(char** pstring,const mxArray* dataref){{{*/
 void FetchData(char** pstring,const mxArray* dataref){
 
@@ -374,5 +381,5 @@
 	/*Ok, the string should be coming directly from the matlab workspace: */
 	if (!mxIsClass(dataref,"char")){
-		_error_("input data_type is not a string!");
+		_error2_("input data_type is not a string!");
 	}
 	else{
@@ -381,5 +388,5 @@
 		
 		stringlen = mxGetM(dataref)*mxGetN(dataref)+1;
-		outstring = (char*)xmalloc(sizeof(mxChar)*stringlen);
+		outstring =xNew<char>(stringlen);
 		mxGetString(dataref,outstring,stringlen);
 	}
@@ -387,6 +394,6 @@
 	/*Assign output pointers:*/
 	*pstring=outstring;
-}
-/*FUNCTION FetchData(char** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{1*/
+}/*}}}*/
+/*FUNCTION FetchData(char** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){{{*/
 void FetchData(char** pmatrix,int* pnumel,int* pndims,int** psize,const mxArray* dataref){
 
@@ -409,5 +416,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 			
@@ -417,9 +424,9 @@
 	if (pndims)*pndims=outmatrix_ndims;
 	if (psize )*psize =outmatrix_size;
-	else xfree((void**)&outmatrix_size);
-
-}
-/*}}}*/
-/*FUNCTION FetchData(double* pscalar,const mxArray* dataref){{{1*/
+	else xDelete<int>(outmatrix_size);
+
+}
+/*}}}*/
+/*FUNCTION FetchData(double* pscalar,const mxArray* dataref){{{*/
 void FetchData(double* pscalar,const mxArray* dataref){
 
@@ -427,5 +434,5 @@
 
 	if (!mxIsClass(dataref,"double")){
-		_error_("input data_type is not a double!");
+		_error2_("input data_type is not a double!");
 	}
 	else{
@@ -438,5 +445,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(int* pinteger,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(int* pinteger,const mxArray* dataref){{{*/
 void FetchData(int* pinteger,const mxArray* dataref){
 
@@ -444,5 +451,5 @@
 
 	if (!mxIsClass(dataref,"double")){
-		_error_("input data_type is not a scalar!");
+		_error2_("input data_type is not a scalar!");
 	}
 	else{
@@ -455,5 +462,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(bool* pboolean,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(bool* pboolean,const mxArray* dataref){{{*/
 void FetchData(bool* pboolean,const mxArray* dataref){
 
@@ -461,10 +468,10 @@
 
 	if (mxIsClass(dataref,"logical")){
-		if(mxGetM(dataref)!=1) _error_("input data is not of size 1x1");
-		if(mxGetN(dataref)!=1) _error_("input data is not of size 1x1");
+		if(mxGetM(dataref)!=1) _error2_("input data is not of size 1x1");
+		if(mxGetN(dataref)!=1) _error2_("input data is not of size 1x1");
 		mxbool_ptr=mxGetLogicals(dataref);
 	}
 	else{
-		_error_("input data_type is not a bool!");
+		_error2_("input data_type is not a bool!");
 	}
 
@@ -474,5 +481,5 @@
 
 /*ISSM objects*/
-/*FUNCTION FetchData(Matrix** pmatrix,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(Matrix** pmatrix,const mxArray* dataref){{{*/
 void FetchData(Matrix** pmatrix,const mxArray* dataref){
 
@@ -488,5 +495,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -495,5 +502,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(Vector** pvector,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(Vector** pvector,const mxArray* dataref){{{*/
 void FetchData(Vector** pvector,const mxArray* dataref){
 
@@ -512,5 +519,5 @@
 	else{
 		/*This is an error: we don't have the correct input!: */
-		_error_("Input parameter of class %s not supported yet",mxGetClassName(dataref));
+		_error2_("Input parameter of class " << mxGetClassName(dataref) << " not supported yet");
 	}
 
@@ -519,5 +526,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(BamgGeom** pbamggeom,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(BamgGeom** pbamggeom,const mxArray* dataref){{{*/
 void FetchData(BamgGeom** pbamggeom,const mxArray* dataref){
 
@@ -538,5 +545,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(BamgMesh** pbamgmesh,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(BamgMesh** pbamgmesh,const mxArray* dataref){{{*/
 void FetchData(BamgMesh** pbamgmesh,const mxArray* dataref){
 
@@ -558,5 +565,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(BamgOpts** pbamgopts,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(BamgOpts** pbamgopts,const mxArray* dataref){{{*/
 void FetchData(BamgOpts** pbamgopts,const mxArray* dataref){
 
@@ -602,5 +609,5 @@
 }
 /*}}}*/
-/*FUNCTION FetchData(Options** poptions,const mxArray* dataref){{{1*/
+/*FUNCTION FetchData(Options** poptions,const mxArray* dataref){{{*/
 void FetchData(Options** poptions,int istart, int nrhs,const mxArray** pdataref){
 
@@ -613,8 +620,8 @@
 	/*Fetch all options*/
 	for (int i=istart; i<nrhs; i=i+2){
-		if (!mxIsClass(pdataref[i],"char")) _error_("Argument %d must be name of option",i+1);
+		if (!mxIsClass(pdataref[i],"char")) _error2_("Argument " << i+1 << " must be name of option");
 
 		FetchData(&name,pdataref[i]);
-		if(i+1 == nrhs) _error_("Argument %d must exist and be value of option \"%s\".",i+2,name);
+		if(i+1 == nrhs) _error2_("Argument " << i+2 << " must exist and be value of option \"" << name << "\".");
 
 		option=(Option*)OptionParse(name,&pdataref[i+1]);
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToDoubleMatrix.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToDoubleMatrix.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToDoubleMatrix.cpp	(revision 12878)
@@ -2,5 +2,4 @@
  * \brief: convert a sparse or dense matlab matrix to a double* pointer
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -10,15 +9,11 @@
 #endif
 
-
 /*Matlab includes: */
 #include "mex.h"
-
 #include "../../shared/shared.h"
 
 int MatlabMatrixToDoubleMatrix(double** pmatrix,int* pmatrix_rows,int* pmatrix_cols,const mxArray* mxmatrix){
 
-	int     i,j,count,rows,cols;
-	double *pmxdoublematrix = NULL;
-	float  *pmxsinglematrix = NULL;
+	int        i,j,count,rows,cols;
 
 	/*output: */
@@ -33,10 +28,10 @@
 
 		/*Dealing with sparse matrix: recover size first: */
-		pmxdoublematrix=(double*)mxGetPr(mxmatrix);
+		double* pmxmatrix=(double*)mxGetPr(mxmatrix);
 		rows=mxGetM(mxmatrix);
 		cols=mxGetN(mxmatrix);
 		
 		if(rows*cols){
-			matrix=(double*)xcalloc(rows*cols,sizeof(double));
+			matrix=xNewZeroInit<double>(rows*cols);
 
 			/*Now, get ir,jc and pr: */
@@ -48,5 +43,5 @@
 			for(i=0;i<cols;i++){
 				for(j=0;j<(jc[i+1]-jc[i]);j++){
-					matrix[rows*ir[count]+i]=pmxdoublematrix[count];
+					matrix[rows*ir[count]+i]=pmxmatrix[count];
 					count++;
 				}
@@ -57,5 +52,5 @@
 	else if(mxIsClass(mxmatrix,"double")){
 		/*Dealing with dense matrix: recover pointer and size: */
-		pmxdoublematrix=(double*)mxGetPr(mxmatrix);
+		double* pmxmatrix=(double*)mxGetPr(mxmatrix);
 		rows=mxGetM(mxmatrix);
 		cols=mxGetN(mxmatrix);
@@ -63,9 +58,9 @@
 		/*Create serial matrix: */
 		if(rows*cols){
-			matrix=(double*)xcalloc(rows*cols,sizeof(double));
+			matrix=xNewZeroInit<double>(rows*cols);
 
 			for(i=0;i<rows;i++){
 				for(j=0;j<cols;j++){
-					matrix[cols*i+j]=(double)pmxdoublematrix[rows*j+i];
+					matrix[cols*i+j]=(double)pmxmatrix[rows*j+i];
 				}
 			}
@@ -74,5 +69,5 @@
 	else if(mxIsClass(mxmatrix,"single")){
 		/*Dealing with dense matrix: recover pointer and size: */
-		pmxsinglematrix=(float*)mxGetPr(mxmatrix);
+		float *pmxmatrix=(float*)mxGetPr(mxmatrix);
 		rows=mxGetM(mxmatrix);
 		cols=mxGetN(mxmatrix);
@@ -80,9 +75,43 @@
 		/*Create serial matrix: */
 		if(rows*cols){
-			matrix=(double*)xcalloc(rows*cols,sizeof(double));
+			matrix=xNewZeroInit<double>(rows*cols);
 
 			for(i=0;i<rows;i++){
 				for(j=0;j<cols;j++){
-					matrix[cols*i+j]=(double)pmxsinglematrix[rows*j+i];
+					matrix[cols*i+j]=(double)pmxmatrix[rows*j+i];
+				}
+			}
+		}
+	}
+	else if(mxIsClass(mxmatrix,"int16")){
+		/*Dealing with dense matrix: recover pointer and size: */
+		short int *pmxmatrix=(short*)mxGetPr(mxmatrix);
+		rows=mxGetM(mxmatrix);
+		cols=mxGetN(mxmatrix);
+
+		/*Create serial matrix: */
+		if(rows*cols){
+			matrix=xNewZeroInit<double>(rows*cols);
+
+			for(i=0;i<rows;i++){
+				for(j=0;j<cols;j++){
+					matrix[cols*i+j]=(double)pmxmatrix[rows*j+i];
+				}
+			}
+		}
+	}
+	else if(mxIsClass(mxmatrix,"uint8")){
+		/*Dealing with dense matrix: recover pointer and size: */
+		char *pmxmatrix=(char*)mxGetPr(mxmatrix);
+		rows=mxGetM(mxmatrix);
+		cols=mxGetN(mxmatrix);
+
+		/*Create serial matrix: */
+		if(rows*cols){
+			matrix=xNewZeroInit<double>(rows*cols);
+
+			for(i=0;i<rows;i++){
+				for(j=0;j<cols;j++){
+					matrix[cols*i+j]=(double)pmxmatrix[rows*j+i];
 				}
 			}
@@ -90,5 +119,5 @@
 	}
 	else{
-		_error_("Matlab matrix type Not implemented yet");
+		_error2_("Matlab matrix type Not implemented yet");
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToMatrix.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToMatrix.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToMatrix.cpp	(revision 12878)
@@ -3,5 +3,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -14,5 +14,5 @@
 #include <string.h>
 #include "./matlabio.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../../shared/shared.h"
 #include "../../Container/Container.h"
@@ -31,7 +31,7 @@
 
 	#ifdef _HAVE_PETSC_
-	MatlabMatrixToPetscMatrix(&matrix->matrix,NULL,NULL,mxmatrix);
+	matrix->pmatrix=MatlabMatrixToPetscMat(mxmatrix);
 	#else
-	matrix->matrix=MatlabMatrixToSeqMat(mxmatrix);
+	matrix->smatrix=MatlabMatrixToSeqMat(mxmatrix);
 	#endif
 	
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToPetscMat.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToPetscMat.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToPetscMat.cpp	(revision 12878)
@@ -0,0 +1,124 @@
+/* \file MatlabMatrixToPetscMatrix.cpp
+ * \brief: convert a sparse or dense matlab matrix to a serial Petsc matrix:
+ */
+
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "../../shared/shared.h"
+
+/*Petsc includes: */
+#include "petscmat.h"
+#include "petscvec.h"
+#include "petscksp.h"
+
+/*Matlab includes: */
+#include "mex.h"
+#include "matlabio.h"
+
+PetscMat* MatlabMatrixToPetscMat(const mxArray* mxmatrix){
+
+	int dummy;
+	PetscMat* matrix=new PetscMat();
+
+	MatlabMatrixToPetscMat(&matrix->matrix, &dummy, &dummy, mxmatrix);
+
+	return matrix;
+}
+int MatlabMatrixToPetscMat(Mat* pmatrix,int* pmatrix_rows,int* pmatrix_cols,const mxArray* mxmatrix){
+
+	int rows, cols;
+	double *mxmatrix_ptr = NULL;
+	double *tmatrix      = NULL;
+	int ierr;
+	int i,j;
+
+	/*output: */
+	Mat matrix = NULL;
+
+	/*matlab indices: */
+	mwIndex *ir = NULL;
+	mwIndex *jc = NULL;
+	double  *pr = NULL;
+	int     count;
+	int     nnz;
+	int     nz;
+
+	/*petsc indices: */
+	int *idxm = NULL;
+	int *idxn = NULL;
+	
+	/*Ok, first check if we are dealing with a sparse or full matrix: */
+	if (mxIsSparse(mxmatrix)){
+
+		/*Dealing with sparse matrix: recover size first: */
+		mxmatrix_ptr=(double*)mxGetPr(mxmatrix);
+		rows=mxGetM(mxmatrix);
+		cols=mxGetN(mxmatrix);
+		nnz=mxGetNzmax(mxmatrix);
+		if(rows){
+			nz=(int)((double)nnz/(double)rows);
+		}
+		else{
+			nz=0;
+		}
+
+		ierr=MatCreateSeqAIJ(PETSC_COMM_SELF,rows,cols,nz,PETSC_NULL,&matrix);CHKERRQ(ierr);
+
+		/*Now, get ir,jc and pr: */
+		pr=mxGetPr(mxmatrix);
+		ir=mxGetIr(mxmatrix);
+		jc=mxGetJc(mxmatrix);
+
+		/*Now, start inserting data into sparse matrix: */
+		count=0;
+		for(i=0;i<cols;i++){
+			for(j=0;j<(jc[i+1]-jc[i]);j++){
+				MatSetValue(matrix,ir[count],i,pr[count],INSERT_VALUES);
+				count++;
+			}
+		}
+	}
+	else{
+		/*Dealing with dense matrix: recover pointer and size: */
+		mxmatrix_ptr=(double*)mxGetPr(mxmatrix);
+		rows=mxGetM(mxmatrix);
+		cols=mxGetN(mxmatrix);
+
+		/*transpose, as Petsc now does not allows MAT_COLUMN_ORIENTED matrices in MatSetValues: */
+		tmatrix=xNew<double>(rows*cols);
+		for(i=0;i<cols;i++){
+			for(j=0;j<rows;j++){
+				*(tmatrix+rows*i+j)=*(mxmatrix_ptr+cols*j+i);
+			}
+		}
+
+		/*Create serial matrix: */
+		ierr=MatCreateSeqDense(PETSC_COMM_SELF,rows,cols,NULL,&matrix);CHKERRQ(ierr);
+
+		/*Insert mxmatrix_ptr values into petsc matrix: */
+		idxm=xNew<int>(rows);
+		idxn=xNew<int>(cols);
+
+		for(i=0;i<rows;i++)idxm[i]=i;
+		for(i=0;i<cols;i++)idxn[i]=i;
+
+		ierr=MatSetValues(matrix,rows,idxm,cols,idxn,tmatrix,INSERT_VALUES); CHKERRQ(ierr);
+
+		xDelete<double>(tmatrix);
+	}
+
+	/*Assemble matrix: */
+	MatAssemblyBegin(matrix,MAT_FINAL_ASSEMBLY); 
+	MatAssemblyEnd(matrix,MAT_FINAL_ASSEMBLY);
+
+	/*Assign output pointer: */
+	*pmatrix=matrix;
+	if(pmatrix_rows) *pmatrix_rows=rows;
+	if(pmatrix_cols) *pmatrix_cols=cols;
+
+	return 1;
+}
Index: issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToSeqMat.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToSeqMat.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/matlab/io/MatlabMatrixToSeqMat.cpp	(revision 12878)
@@ -3,5 +3,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
